import * as Base64 from 'js-base64';
import { toUint8Array, fromUint8Array } from 'js-base64';
import nodeLocalStorage from 'node-localstorage';
import { join } from 'path';
import axios from 'axios';
import crypto from 'crypto';
import protobufjs from 'protobufjs';
import { v4 } from 'uuid';
import sha256 from 'crypto-js/sha256';
import encBase64 from 'crypto-js/enc-base64';
import { utils as utils$1, ethers } from 'ethers';
export { ethers } from 'ethers';
import Long from 'long';
import qs from 'query-string';

var AnnounceType;

(function (AnnounceType) {
  AnnounceType[AnnounceType["AS_USER"] = 0] = "AS_USER";
  AnnounceType[AnnounceType["AS_PRODUCER"] = 1] = "AS_PRODUCER";
  AnnounceType[AnnounceType["AS_USER_ENCRYPT"] = 2] = "AS_USER_ENCRYPT";
})(AnnounceType || (AnnounceType = {}));

var ApproveType;

(function (ApproveType) {
  ApproveType[ApproveType["ANNOUNCED"] = 0] = "ANNOUNCED";
  ApproveType[ApproveType["APPROVED"] = 1] = "APPROVED";
  ApproveType[ApproveType["REJECTED"] = 2] = "REJECTED";
})(ApproveType || (ApproveType = {}));

var ActionType;

(function (ActionType) {
  ActionType[ActionType["ADD"] = 0] = "ADD";
  ActionType[ActionType["REMOVE"] = 1] = "REMOVE";
})(ActionType || (ActionType = {}));

function _regeneratorRuntime() {
  /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */

  _regeneratorRuntime = function () {
    return exports;
  };

  var exports = {},
      Op = Object.prototype,
      hasOwn = Op.hasOwnProperty,
      $Symbol = "function" == typeof Symbol ? Symbol : {},
      iteratorSymbol = $Symbol.iterator || "@@iterator",
      asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
      toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function define(obj, key, value) {
    return Object.defineProperty(obj, key, {
      value: value,
      enumerable: !0,
      configurable: !0,
      writable: !0
    }), obj[key];
  }

  try {
    define({}, "");
  } catch (err) {
    define = function (obj, key, value) {
      return obj[key] = value;
    };
  }

  function wrap(innerFn, outerFn, self, tryLocsList) {
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
        generator = Object.create(protoGenerator.prototype),
        context = new Context(tryLocsList || []);
    return generator._invoke = function (innerFn, self, context) {
      var state = "suspendedStart";
      return function (method, arg) {
        if ("executing" === state) throw new Error("Generator is already running");

        if ("completed" === state) {
          if ("throw" === method) throw arg;
          return doneResult();
        }

        for (context.method = method, context.arg = arg;;) {
          var delegate = context.delegate;

          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);

            if (delegateResult) {
              if (delegateResult === ContinueSentinel) continue;
              return delegateResult;
            }
          }

          if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
            if ("suspendedStart" === state) throw state = "completed", context.arg;
            context.dispatchException(context.arg);
          } else "return" === context.method && context.abrupt("return", context.arg);
          state = "executing";
          var record = tryCatch(innerFn, self, context);

          if ("normal" === record.type) {
            if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
            return {
              value: record.arg,
              done: context.done
            };
          }

          "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
        }
      };
    }(innerFn, self, context), generator;
  }

  function tryCatch(fn, obj, arg) {
    try {
      return {
        type: "normal",
        arg: fn.call(obj, arg)
      };
    } catch (err) {
      return {
        type: "throw",
        arg: err
      };
    }
  }

  exports.wrap = wrap;
  var ContinueSentinel = {};

  function Generator() {}

  function GeneratorFunction() {}

  function GeneratorFunctionPrototype() {}

  var IteratorPrototype = {};
  define(IteratorPrototype, iteratorSymbol, function () {
    return this;
  });
  var getProto = Object.getPrototypeOf,
      NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
  var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);

  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function (method) {
      define(prototype, method, function (arg) {
        return this._invoke(method, arg);
      });
    });
  }

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);

      if ("throw" !== record.type) {
        var result = record.arg,
            value = result.value;
        return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
          invoke("next", value, resolve, reject);
        }, function (err) {
          invoke("throw", err, resolve, reject);
        }) : PromiseImpl.resolve(value).then(function (unwrapped) {
          result.value = unwrapped, resolve(result);
        }, function (error) {
          return invoke("throw", error, resolve, reject);
        });
      }

      reject(record.arg);
    }

    var previousPromise;

    this._invoke = function (method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function (resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
    };
  }

  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];

    if (undefined === method) {
      if (context.delegate = null, "throw" === context.method) {
        if (delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel;
        context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);
    if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
    var info = record.arg;
    return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
  }

  function pushTryEntry(locs) {
    var entry = {
      tryLoc: locs[0]
    };
    1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal", delete record.arg, entry.completion = record;
  }

  function Context(tryLocsList) {
    this.tryEntries = [{
      tryLoc: "root"
    }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
  }

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) return iteratorMethod.call(iterable);
      if ("function" == typeof iterable.next) return iterable;

      if (!isNaN(iterable.length)) {
        var i = -1,
            next = function next() {
          for (; ++i < iterable.length;) if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;

          return next.value = undefined, next.done = !0, next;
        };

        return next.next = next;
      }
    }

    return {
      next: doneResult
    };
  }

  function doneResult() {
    return {
      value: undefined,
      done: !0
    };
  }

  return GeneratorFunction.prototype = GeneratorFunctionPrototype, define(Gp, "constructor", GeneratorFunctionPrototype), define(GeneratorFunctionPrototype, "constructor", GeneratorFunction), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
    var ctor = "function" == typeof genFun && genFun.constructor;
    return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
  }, exports.mark = function (genFun) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
  }, exports.awrap = function (arg) {
    return {
      __await: arg
    };
  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
    return this;
  }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    void 0 === PromiseImpl && (PromiseImpl = Promise);
    var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
    return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
      return result.done ? result.value : iter.next();
    });
  }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
    return this;
  }), define(Gp, "toString", function () {
    return "[object Generator]";
  }), exports.keys = function (object) {
    var keys = [];

    for (var key in object) keys.push(key);

    return keys.reverse(), function next() {
      for (; keys.length;) {
        var key = keys.pop();
        if (key in object) return next.value = key, next.done = !1, next;
      }

      return next.done = !0, next;
    };
  }, exports.values = values, Context.prototype = {
    constructor: Context,
    reset: function (skipTempReset) {
      if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
    },
    stop: function () {
      this.done = !0;
      var rootRecord = this.tryEntries[0].completion;
      if ("throw" === rootRecord.type) throw rootRecord.arg;
      return this.rval;
    },
    dispatchException: function (exception) {
      if (this.done) throw exception;
      var context = this;

      function handle(loc, caught) {
        return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i],
            record = entry.completion;
        if ("root" === entry.tryLoc) return handle("end");

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc"),
              hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
          } else {
            if (!hasFinally) throw new Error("try statement without catch or finally");
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          }
        }
      }
    },
    abrupt: function (type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
      var record = finallyEntry ? finallyEntry.completion : {};
      return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
    },
    complete: function (record, afterLoc) {
      if ("throw" === record.type) throw record.arg;
      return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
    },
    finish: function (finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
      }
    },
    catch: function (tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;

          if ("throw" === record.type) {
            var thrown = record.arg;
            resetTryEntry(entry);
          }

          return thrown;
        }
      }

      throw new Error("illegal catch attempt");
    },
    delegateYield: function (iterable, resultName, nextLoc) {
      return this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
    }
  }, exports;
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };
  return _extends.apply(this, arguments);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it) return (it = it.call(o)).next.bind(it);

  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it) o = it;
    var i = 0;
    return function () {
      if (i >= o.length) return {
        done: true
      };
      return {
        done: false,
        value: o[i++]
      };
    };
  }

  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var hexToUint8Array = function hexToUint8Array(hexString) {
  return Uint8Array.from(hexString.match(/.{1,2}/g).map(function (_byte) {
    return parseInt(_byte, 16);
  }));
};
var uint8ArrayToHex = function uint8ArrayToHex(buffer) {
  return new Uint8Array(buffer).reduce(function (str, _byte2) {
    return str + _byte2.toString(16).padStart(2, '0');
  }, '');
};
var uint8ArrayToString = function uint8ArrayToString(buffer) {
  return new TextDecoder().decode(buffer);
};
var stringToUint8Array = function stringToUint8Array(str) {
  return new TextEncoder().encode(str);
};

var typeTransform = {
  __proto__: null,
  hexToUint8Array: hexToUint8Array,
  uint8ArrayToHex: uint8ArrayToHex,
  uint8ArrayToString: uint8ArrayToString,
  stringToUint8Array: stringToUint8Array
};

var formatBase64UUID = (function (base64) {
  var groupIdWithoutDashes = uint8ArrayToHex(toUint8Array(base64));
  return addDashesToUuid(groupIdWithoutDashes);
});

var addDashesToUuid = function addDashesToUuid(i) {
  return i.slice(0, 8) + "-" + i.slice(8, 12) + "-" + i.slice(12, 16) + "-" + i.slice(16, 20) + "-" + i.slice(20);
};

var restoreSeedFromUrl = (function (url) {
  var isValidUrl = url.startsWith('rum://seed?');

  if (!isValidUrl) {
    throw new Error('invalid url');
  }

  var seed = {
    genesis_block: {
      BlockId: '',
      GroupId: '',
      PrevBlockId: '',
      PreviousHash: null,
      TimeStamp: 0,
      ProducerPubKey: '',
      Trxs: null,
      Signature: ''
    },
    group_name: '',
    consensus_type: '',
    encryption_type: '',
    cipher_key: '',
    group_id: '',
    owner_pubkey: '',
    signature: '',
    app_key: '',
    urls: []
  };
  url = url.replaceAll('?jwt', '_jwt');
  var searchParams = url.split('?')[1];
  var urlParams = new URLSearchParams(searchParams);
  var pVersion = urlParams.get('v') || '';

  if (pVersion !== '1') {
    throw new Error('nonsupport version');
  }

  seed.group_name = urlParams.get('a') || '';
  var groupId = formatBase64UUID(urlParams.get('g') || '');
  seed.genesis_block.GroupId = groupId;
  seed.group_id = groupId;
  var blockId = formatBase64UUID(urlParams.get('b') || '');
  seed.genesis_block.BlockId = blockId;
  var signature = fromUint8Array(toUint8Array(urlParams.get('s') || ''));
  seed.genesis_block.Signature = signature;
  seed.signature = signature;
  seed.genesis_block.ProducerPubKey = urlParams.get('k') || '';
  seed.owner_pubkey = urlParams.get('k') || '';
  var cipher = uint8ArrayToHex(toUint8Array(urlParams.get('c') || ''));
  seed.cipher_key = cipher;
  seed.app_key = urlParams.get('y') || '';
  seed.consensus_type = urlParams.get('n') === '1' ? 'pos' : 'poa';
  seed.encryption_type = urlParams.get('e') === '0' ? 'public' : 'private'; // const base64Timestamp = Base64.toUint8Array(urlParams.get('t') || '');
  // seed.genesis_block.TimeStamp = base64Timestamp;

  var pUrl = urlParams.get('u') || '';

  for (var _iterator = _createForOfIteratorHelperLoose(pUrl.split('|')), _step; !(_step = _iterator()).done;) {
    var _url = _step.value;
    seed.urls.push(_url.replace('_jwt', '?jwt'));
  }

  return seed;
});

var seedUrlToGroup = (function (seedUrl) {
  var seed = restoreSeedFromUrl(seedUrl);
  return {
    groupId: seed.group_id,
    groupName: seed.group_name,
    consensusType: seed.consensus_type,
    encryptionType: seed.encryption_type,
    cipherKey: seed.cipher_key,
    appKey: seed.app_key,
    ownerPubKey: seed.owner_pubkey,
    signature: seed.signature,
    chainAPIs: seed.urls
  };
});

var assert = function assert(condition, errorMessage) {
  if (!condition) {
    throw new Error(errorMessage);
  }
};
var error = {
  required: function required(name) {
    return name + " is required";
  },
  notFound: function notFound(name) {
    return name + " not found";
  },
  invalid: function invalid(name) {
    return name + " is invalid";
  }
};

var storagePath = /*#__PURE__*/join(__dirname, "./localStorage");
var localStorage = /*#__PURE__*/new nodeLocalStorage.LocalStorage(storagePath);

var store = function store(key, data) {
  if (!data) {
    var value = localStorage.getItem(key);
    return value ? JSON.parse(value) : '';
  }

  localStorage.setItem(key, JSON.stringify(data));
};

var STORE_KEY = 'lightNodeGroupMap';
var list = function list() {
  return Object.values(store(STORE_KEY) || {});
};
var add = function add(seedUrl) {
  var map = store(STORE_KEY) || {};
  var group = seedUrlToGroup(seedUrl);
  assert(group.chainAPIs.length > 0, error.notFound('chain url'));

  if (map[group.groupId]) {
    return {
      groupId: group.groupId
    };
  }

  map[group.groupId] = group;
  store(STORE_KEY, map);
  return {
    groupId: group.groupId
  };
};
var remove = function remove(groupId) {
  assert(groupId, "groupId is required");
  var map = store(STORE_KEY) || {};
  delete map[groupId];
  store(STORE_KEY, map);
  return {
    groupId: groupId
  };
};
var get = function get(groupId) {
  assert(groupId, "groupId is required");
  var map = store(STORE_KEY) || {};
  return map[groupId];
};
var update = function update(groupId, group) {
  assert(groupId, "groupId is required");
  assert(group, "group is required");
  var map = store(STORE_KEY) || {};
  map[groupId] = group;
  store(STORE_KEY, map);
  return {
    groupId: groupId
  };
};
var clear = function clear() {
  localStorage.removeItem(STORE_KEY);
};

var group = {
  __proto__: null,
  list: list,
  add: add,
  remove: remove,
  get: get,
  update: update,
  clear: clear
};



var cache = {
  __proto__: null,
  Group: group
};

var encrypt = function encrypt(buffer, key) {
  assert(buffer, error.required('buffer'));
  assert(key, error.required('key'));
  var nonce = getRandomIV();
  var cipher = crypto.createCipheriv('aes-256-gcm', hexToUint8Array(key), nonce);
  var nonceCiphertextTag = Buffer.concat([nonce, cipher.update(buffer), cipher["final"](), cipher.getAuthTag()]);
  return nonceCiphertextTag;
};

function getRandomIV() {
  return crypto.randomBytes(12);
}

var decrypt = function decrypt(buffer, key) {
  var nonce = buffer.slice(0, 12);
  var ciphertext = buffer.slice(12, -16);
  var tag = buffer.slice(-16); // Separate tag!

  var decipher = crypto.createDecipheriv('aes-256-gcm', hexToUint8Array(key), nonce);
  decipher.setAuthTag(tag);
  var decrypted = Buffer.concat([decipher.update(ciphertext), decipher["final"]()]);
  return decrypted;
};

var AEScrypto = {
  __proto__: null,
  encrypt: encrypt,
  decrypt: decrypt
};

var create = function create(_ref) {
  var type = _ref.type,
      payload = _ref.payload;
  var root = protobufjs.Root.fromJSON(jsonDescriptor);
  var object = root.lookupType(type);
  var errMsg = object.verify(payload);

  if (errMsg) {
    throw new Error(errMsg);
  }

  var message = object.create(payload);
  var buffer = object.encode(message).finish();
  return new Uint8Array(buffer);
};
var toObject = function toObject(_ref2) {
  var type = _ref2.type,
      buffer = _ref2.buffer;

  try {
    var root = protobufjs.Root.fromJSON(jsonDescriptor);
    var object = root.lookupType(type);
    var message = object.decode(buffer);
    var result = object.toObject(message);
    return result;
  } catch (_) {}

  return {};
};
var jsonDescriptor = {
  "nested": {
    "quorum": {
      "nested": {
        "pb": {
          "nested": {
            "Trx": {
              "fields": {
                "TrxId": {
                  "type": "string",
                  "id": 1
                },
                "Type": {
                  "type": "string",
                  "id": 2
                },
                "GroupId": {
                  "type": "string",
                  "id": 3
                },
                "Data": {
                  "type": "bytes",
                  "id": 4
                },
                "TimeStamp": {
                  "type": "int64",
                  "id": 5
                },
                "Version": {
                  "type": "string",
                  "id": 6
                },
                "Expired": {
                  "type": "int64",
                  "id": 7
                },
                "ResendCount": {
                  "type": "int64",
                  "id": 8
                },
                "Nonce": {
                  "type": "int64",
                  "id": 9
                },
                "SenderPubkey": {
                  "type": "string",
                  "id": 10
                },
                "SenderSign": {
                  "type": "bytes",
                  "id": 11
                },
                "StorageType": {
                  "type": "string",
                  "id": 12
                }
              }
            },
            "AnnounceItem": {
              "fields": {
                "GroupId": {
                  "type": "string",
                  "id": 1
                },
                "SignPubkey": {
                  "type": "string",
                  "id": 2
                },
                "EncryptPubkey": {
                  "type": "string",
                  "id": 3
                },
                "AnnouncerSignature": {
                  "type": "string",
                  "id": 4
                },
                "Type": {
                  "type": "int64",
                  "id": 5
                },
                "OwnerPubkey": {
                  "type": "string",
                  "id": 6
                },
                "OwnerSignature": {
                  "type": "string",
                  "id": 7
                },
                "Result": {
                  "type": "int64",
                  "id": 8
                },
                "TimeStamp": {
                  "type": "int64",
                  "id": 9
                },
                "Action": {
                  "type": "int64",
                  "id": 10
                },
                "Memo": {
                  "type": "string",
                  "id": 11
                }
              }
            }
          }
        }
      }
    }
  }
};

var protobuf = {
  __proto__: null,
  create: create,
  toObject: toObject
};

var signTrx = /*#__PURE__*/function () {
  var _ref = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(payload) {
    var _payload$publicKey;

    var groupId, data, trxId, version, aesKey, privateKey, account, dataBuffer, encrypted, now, timestampNanoString, senderPubkey, trx, trxWithoutSignProtoBuffer, trxWithoutSignProtoBase64, hash, signature, signatureBuffer, SenderSign;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            groupId = payload.groupId, data = payload.data, trxId = payload.trxId, version = payload.version, aesKey = payload.aesKey, privateKey = payload.privateKey;
            assert(groupId, error.required('groupId'));
            assert(data, error.required('data'));
            assert(aesKey, error.required('aesKey'));

            if (!(!privateKey && !payload.sign)) {
              _context.next = 9;
              break;
            }

            _context.next = 7;
            return getProviderAccount();

          case 7:
            account = _context.sent;
            assert(account, error.notFound('provider account'));

          case 9:
            dataBuffer = stringToUint8Array(JSON.stringify(data));
            encrypted = new Uint8Array();
            _context.next = 13;
            return encrypt(dataBuffer, aesKey);

          case 13:
            encrypted = _context.sent;
            now = new Date();
            timestampNanoString = now.getTime() + "000000";

            if (!((_payload$publicKey = payload.publicKey) != null)) {
              _context.next = 20;
              break;
            }

            _context.t0 = _payload$publicKey;
            _context.next = 23;
            break;

          case 20:
            _context.next = 22;
            return getSenderPubkey(privateKey);

          case 22:
            _context.t0 = _context.sent;

          case 23:
            senderPubkey = _context.t0;
            trx = {
              TrxId: trxId || v4(),
              GroupId: groupId,
              Data: fromUint8Array(new Uint8Array(encrypted)),
              TimeStamp: Long.fromValue(timestampNanoString),
              Version: version || '2.0.0',
              SenderPubkey: senderPubkey
            };
            trxWithoutSignProtoBuffer = create({
              type: 'quorum.pb.Trx',
              payload: trx
            });
            trxWithoutSignProtoBase64 = fromUint8Array(new Uint8Array(trxWithoutSignProtoBuffer));
            hash = sha256(encBase64.parse(trxWithoutSignProtoBase64)).toString();
            _context.next = 30;
            return sign(hash, {
              privateKey: privateKey,
              sign: payload.sign
            });

          case 30:
            signature = _context.sent;
            signatureBuffer = hexToUint8Array(signature);
            SenderSign = fromUint8Array(new Uint8Array(signatureBuffer));
            return _context.abrupt("return", {
              trx_id: trx.TrxId,
              group_id: trx.GroupId,
              data: trx.Data,
              timestamp: timestampNanoString,
              version: trx.Version,
              sender_pubkey: trx.SenderPubkey,
              sender_sign: SenderSign
            });

          case 34:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function signTrx(_x) {
    return _ref.apply(this, arguments);
  };
}();
var getSenderPubkey = /*#__PURE__*/function () {
  var _ref2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(privateKey) {
    var signingKey, pubKeyBuffer, address;
    return _regeneratorRuntime().wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (!privateKey) {
              _context2.next = 6;
              break;
            }

            signingKey = new utils$1.SigningKey(privateKey);
            pubKeyBuffer = hexToUint8Array(signingKey.compressedPublicKey.replace('0x', ''));
            return _context2.abrupt("return", fromUint8Array(pubKeyBuffer, true));

          case 6:
            _context2.next = 8;
            return getProviderAccount();

          case 8:
            address = _context2.sent;
            return _context2.abrupt("return", address);

          case 10:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function getSenderPubkey(_x2) {
    return _ref2.apply(this, arguments);
  };
}();
var sign = /*#__PURE__*/function () {
  var _ref3 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(hash, params) {
    var signingKey, digest, signatureObj, account, provider, signatureFromProvider;
    return _regeneratorRuntime().wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if (!params.sign) {
              _context3.next = 4;
              break;
            }

            return _context3.abrupt("return", params.sign(hash));

          case 4:
            if (!params.privateKey) {
              _context3.next = 11;
              break;
            }

            signingKey = new utils$1.SigningKey(params.privateKey);
            digest = hexToUint8Array(hash);
            signatureObj = signingKey.signDigest(digest);
            return _context3.abrupt("return", utils$1.joinSignature(signatureObj).replace('0x', ''));

          case 11:
            _context3.next = 13;
            return getProviderAccount();

          case 13:
            account = _context3.sent;
            provider = new ethers.providers.Web3Provider(window.ethereum);
            _context3.next = 17;
            return provider.send("eth_sign", [account, '0x' + hash]);

          case 17:
            signatureFromProvider = _context3.sent;
            return _context3.abrupt("return", utils$1.joinSignature(signatureFromProvider).replace('0x', ''));

          case 19:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  return function sign(_x3, _x4) {
    return _ref3.apply(this, arguments);
  };
}();

var getProviderAccount = /*#__PURE__*/function () {
  var _ref4 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4() {
    var provider, accounts;
    return _regeneratorRuntime().wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            provider = new ethers.providers.Web3Provider(window.ethereum);
            _context4.next = 3;
            return provider.send("eth_requestAccounts", []);

          case 3:
            accounts = _context4.sent;
            return _context4.abrupt("return", accounts[0]);

          case 5:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));

  return function getProviderAccount() {
    return _ref4.apply(this, arguments);
  };
}();

var pubkeyToAddress = (function (basePubKeyOrAddress) {
  if (ethers.utils.isAddress(basePubKeyOrAddress)) {
    return basePubKeyOrAddress;
  }

  var u8s = toUint8Array(basePubKeyOrAddress);
  var publicKey = uint8ArrayToHex(u8s);
  return ethers.utils.computeAddress("0x" + publicKey);
});

var verifyTrx = function verifyTrx(trx) {
  var pbTrx = {
    GroupId: trx.GroupId,
    Data: trx.Data,
    SenderPubkey: trx.SenderPubkey,
    TimeStamp: Long.fromValue(trx.TimeStamp),
    TrxId: trx.TrxId,
    Version: trx.Version
  };

  if (trx.Expired) {
    pbTrx.Expired = Long.fromValue(trx.Expired);
  }

  var trxWithoutSignProtoBuffer = create({
    type: 'quorum.pb.Trx',
    payload: pbTrx
  });
  var trxWithoutSignProtoBase64 = fromUint8Array(new Uint8Array(trxWithoutSignProtoBuffer));
  var hash = sha256(encBase64.parse(trxWithoutSignProtoBase64)).toString();
  var digest = hexToUint8Array(hash);
  var signature = uint8ArrayToHex(toUint8Array(trx.SenderSign));
  var recoveredAddress = ethers.utils.recoverAddress(digest, "0x" + signature);
  var address = pubkeyToAddress(trx.SenderPubkey);
  console.log("[verifyTrx]:", {
    signature: signature,
    address: address,
    recoveredAddress: recoveredAddress
  });
  return address === recoveredAddress;
};



var utils = {
  __proto__: null,
  AEScrypto: AEScrypto,
  protobuf: protobuf,
  typeTransform: typeTransform,
  Base64: Base64,
  formatBase64UUID: formatBase64UUID,
  restoreSeedFromUrl: restoreSeedFromUrl,
  seedUrlToGroup: seedUrlToGroup,
  pubkeyToAddress: pubkeyToAddress,
  signTrx: signTrx,
  getSenderPubkey: getSenderPubkey,
  sign: sign,
  verifyTrx: verifyTrx
};

var get$1 = /*#__PURE__*/function () {
  var _ref = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(groupId, trxId) {
    var group, apiURL, res;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            assert(groupId, error.required('groupId'));
            assert(trxId, error.required('trxId'));
            group = get(groupId);
            assert(group, error.notFound('group'));
            apiURL = new URL(group.chainAPIs[0]);
            _context.next = 7;
            return axios.get(apiURL.origin + "/api/v1/trx/" + groupId + "/" + trxId, {
              headers: {
                Authorization: "Bearer " + (apiURL.searchParams.get('jwt') || '')
              }
            });

          case 7:
            res = _context.sent;
            return _context.abrupt("return", res.data);

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function get(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();
var create$1 = /*#__PURE__*/function () {
  var _ref2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(p) {
    var group, payload, apiURL, res;
    return _regeneratorRuntime().wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            group = get(p.groupId);
            assert(group, error.notFound('group'));
            _context2.next = 4;
            return signTrx(_extends({
              aesKey: group.cipherKey
            }, p, {
              data: p.data
            }));

          case 4:
            payload = _context2.sent;
            apiURL = new URL(group.chainAPIs[0]);
            _context2.next = 8;
            return axios.post(apiURL.origin + "/api/v1/node/" + p.groupId + "/trx", payload, {
              headers: {
                Authorization: "Bearer " + (apiURL.searchParams.get('jwt') || '')
              }
            });

          case 8:
            res = _context2.sent;
            return _context2.abrupt("return", res.data);

          case 10:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function create(_x3) {
    return _ref2.apply(this, arguments);
  };
}();
var send = /*#__PURE__*/function () {
  var _ref3 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(groupId, payload) {
    var group, apiURL, res;
    return _regeneratorRuntime().wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            group = get(groupId);
            assert(group, error.notFound('group'));
            apiURL = new URL(group.chainAPIs[0]);
            _context3.next = 5;
            return axios.post(apiURL.origin + "/api/v1/node/" + groupId + "/trx", payload, {
              headers: {
                Authorization: "Bearer " + (apiURL.searchParams.get('jwt') || '')
              }
            });

          case 5:
            res = _context3.sent;
            return _context3.abrupt("return", res.data);

          case 7:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  return function send(_x4, _x5) {
    return _ref3.apply(this, arguments);
  };
}();

var trx = {
  __proto__: null,
  get: get$1,
  create: create$1,
  send: send
};

var list$1 = /*#__PURE__*/function () {
  var _ref = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(options) {
    var groupId, group, params, apiURL, res, contents;
    return _regeneratorRuntime().wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            groupId = options.groupId;
            group = get(groupId);
            assert(group, error.notFound('group'));
            params = {
              group_id: groupId,
              reverse: options.reverse ? "true" : "false",
              include_start_trx: "false",
              senders: []
            };

            if (options.startTrx) {
              params.start_trx = options.startTrx;
            }

            if (options.count) {
              params.num = options.count;
            }

            apiURL = new URL(group.chainAPIs[0]);
            _context2.next = 9;
            return axios.get(apiURL.origin + "/api/v1/node/" + groupId + "/groupctn?" + qs.stringify(params), {
              headers: {
                Authorization: "Bearer " + (apiURL.searchParams.get('jwt') || ''),
                'Accept-Content': 'gzip'
              }
            });

          case 9:
            res = _context2.sent;
            _context2.next = 12;
            return Promise.all(res.data.map( /*#__PURE__*/function () {
              var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(item) {
                var encryptedBuffer, buffer, dataString, data;
                return _regeneratorRuntime().wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        if (!(!item || Object.keys(item).length === 0)) {
                          _context.next = 2;
                          break;
                        }

                        return _context.abrupt("return", null);

                      case 2:
                        encryptedBuffer = toUint8Array(item.Data);

                        if (!((group == null ? void 0 : group.encryptionType) === 'private')) {
                          _context.next = 5;
                          break;
                        }

                        return _context.abrupt("return", item);

                      case 5:
                        _context.next = 7;
                        return decrypt(encryptedBuffer, group.cipherKey);

                      case 7:
                        buffer = _context.sent;
                        dataString = uint8ArrayToString(buffer);
                        data = {};

                        try {
                          data = JSON.parse(dataString);
                        } catch (err) {
                          console.log("[fail to parse json for trx.Data]:", {
                            item: item,
                            dataString: dataString
                          });
                          console.log(err);
                        }

                        return _context.abrupt("return", _extends({}, item, {
                          Data: data
                        }));

                      case 12:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function (_x2) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 12:
            contents = _context2.sent;
            return _context2.abrupt("return", contents.filter(function (content) {
              return !!content;
            }));

          case 14:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function list(_x) {
    return _ref.apply(this, arguments);
  };
}();

var content = {
  __proto__: null,
  list: list$1
};

var list$2 = /*#__PURE__*/function () {
  var _ref = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(options) {
    var groupId, group, params, getGroupCtnItemJsonString, plaintextEncoded, encrypted, sendJson, apiURL, res;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            groupId = options.groupId;
            group = get(groupId);
            assert(group, error.notFound('group'));
            params = {
              GroupId: groupId
            };
            getGroupCtnItemJsonString = JSON.stringify(params);
            plaintextEncoded = new TextEncoder().encode(getGroupCtnItemJsonString);
            _context.next = 8;
            return encrypt(plaintextEncoded, group.cipherKey);

          case 8:
            encrypted = _context.sent;
            sendJson = {
              Req: fromUint8Array(new Uint8Array(encrypted)),
              GroupId: groupId,
              ReqType: 'appconfig_listlist'
            };
            apiURL = new URL(group.chainAPIs[0]);
            _context.next = 13;
            return axios.post(apiURL.origin + "/api/v1/node/getchaindata/" + groupId, sendJson, {
              headers: {
                Authorization: "Bearer " + (apiURL.searchParams.get('jwt') || ''),
                'Accept-Content': 'gzip'
              }
            });

          case 13:
            res = _context.sent;
            return _context.abrupt("return", res.data);

          case 15:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function list(_x) {
    return _ref.apply(this, arguments);
  };
}();
var get$2 = /*#__PURE__*/function () {
  var _ref2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(options) {
    var groupId, key, group, params, getGroupCtnItemJsonString, plaintextEncoded, encrypted, sendJson, apiURL, res;
    return _regeneratorRuntime().wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            groupId = options.groupId, key = options.key;
            group = get(groupId);
            assert(group, error.notFound('group'));
            params = {
              GroupId: groupId,
              Key: key
            };
            getGroupCtnItemJsonString = JSON.stringify(params);
            plaintextEncoded = new TextEncoder().encode(getGroupCtnItemJsonString);
            _context2.next = 8;
            return encrypt(plaintextEncoded, group.cipherKey);

          case 8:
            encrypted = _context2.sent;
            sendJson = {
              Req: fromUint8Array(new Uint8Array(encrypted)),
              GroupId: groupId,
              ReqType: 'appconfig_item_bykey'
            };
            apiURL = new URL(group.chainAPIs[0]);
            _context2.next = 13;
            return axios.post(apiURL.origin + "/api/v1/node/getchaindata/" + groupId, sendJson, {
              headers: {
                Authorization: "Bearer " + (apiURL.searchParams.get('jwt') || ''),
                'Accept-Content': 'gzip'
              }
            });

          case 13:
            res = _context2.sent;
            return _context2.abrupt("return", res.data);

          case 15:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function get(_x2) {
    return _ref2.apply(this, arguments);
  };
}();

var appconfig = {
  __proto__: null,
  list: list$2,
  get: get$2
};

var announce = /*#__PURE__*/function () {
  var _ref = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(options) {
    var groupId, privateKey, encryptPubKey, type, action, group, senderPubkey, p, data, hash, signature, dataBuffer, encrypted, payload, apiURL, res;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            groupId = options.groupId, privateKey = options.privateKey, encryptPubKey = options.encryptPubKey, type = options.type, action = options.action;
            group = get(groupId);
            assert(group, error.notFound('group'));
            assert(privateKey, error.required('privateKey'));
            assert(encryptPubKey, error.required('encryptPubKey'));
            _context.next = 7;
            return getSenderPubkey(privateKey);

          case 7:
            senderPubkey = _context.sent;
            p = {
              GroupId: groupId,
              Type: type || AnnounceType.AS_USER,
              Action: action || ActionType.ADD,
              SignPubkey: senderPubkey,
              EncryptPubkey: encryptPubKey,
              OwnerPubkey: '',
              OwnerSignature: '',
              Result: ApproveType.ANNOUNCED,
              AnnouncerSignature: '',
              TimeStamp: Date.now() * 1000000,
              Memo: ''
            };
            data = p.GroupId + p.SignPubkey + p.EncryptPubkey;
            hash = sha256(data).toString();
            _context.next = 13;
            return sign(hash, {
              privateKey: privateKey
            });

          case 13:
            signature = _context.sent;
            p.AnnouncerSignature = signature;
            dataBuffer = create({
              type: 'quorum.pb.AnnounceItem',
              payload: p
            });
            _context.next = 18;
            return encrypt(dataBuffer, group.cipherKey);

          case 18:
            encrypted = _context.sent;
            payload = {
              group_id: groupId,
              Req: fromUint8Array(new Uint8Array(encrypted))
            };
            apiURL = new URL(group.chainAPIs[0]);
            _context.next = 23;
            return axios.post(apiURL.origin + "/api/v1/node/announce/" + groupId, payload, {
              headers: {
                Authorization: "Bearer " + (apiURL.searchParams.get('jwt') || '')
              }
            });

          case 23:
            res = _context.sent;
            return _context.abrupt("return", res.data);

          case 25:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function announce(_x) {
    return _ref.apply(this, arguments);
  };
}();
var getEncryptPubKeys = /*#__PURE__*/function () {
  var _ref2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(groupId) {
    var group, apiURL, res;
    return _regeneratorRuntime().wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            group = get(groupId);
            assert(group, error.notFound('group'));
            apiURL = new URL(group.chainAPIs[0]);
            _context2.next = 5;
            return axios.get(apiURL.origin + "/api/v1/node/getencryptpubkeys/" + groupId, {
              headers: {
                Authorization: "Bearer " + (apiURL.searchParams.get('jwt') || '')
              }
            });

          case 5:
            res = _context2.sent;
            return _context2.abrupt("return", res.data);

          case 7:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function getEncryptPubKeys(_x2) {
    return _ref2.apply(this, arguments);
  };
}();

var auth = {
  __proto__: null,
  announce: announce,
  getEncryptPubKeys: getEncryptPubKeys
};



var chain = {
  __proto__: null,
  Trx: trx,
  Content: content,
  AppConfig: appconfig,
  Auth: auth
};

var UUID_REGEX = /[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}/i;
var apiLoopIndexMap = {};
var interceptAxios = function interceptAxios() {
  axios.defaults.timeout = 30 * 1000;
  axios.interceptors.response.use(function (response) {
    try {
      var matched = response.config.url.match(UUID_REGEX);

      if (matched) {
        var groupId = matched[0];

        if (groupId) {
          var group = get(groupId);

          if (group) {
            var loopIndex = apiLoopIndexMap[groupId] || 0;

            if (group.chainAPIs.length > 0 && loopIndex > 0) {
              arrayMove(group.chainAPIs, loopIndex, 0);
              update(groupId, group);
              apiLoopIndexMap[groupId] = 0;
            }
          }
        }
      }
    } catch (err) {
      console.log(err);
    }

    return response;
  }, function (error) {
    var matched = error.config.url.match(UUID_REGEX);

    if (matched) {
      var groupId = matched[0];

      if (groupId) {
        var group = get(groupId);
        var chainAPIs = group.chainAPIs;

        if (chainAPIs.length === 1) {
          return Promise.reject(error);
        }

        var curIndex = (apiLoopIndexMap[group.groupId] || 0) + 1;

        if (curIndex <= chainAPIs.length - 1) {
          var alternativeUrl = new URL(chainAPIs[curIndex]);
          var errorRequestUrl = new URL(error.config.url);
          apiLoopIndexMap[group.groupId] = curIndex;
          var requestOptions = {
            url: "" + alternativeUrl.origin + errorRequestUrl.pathname + errorRequestUrl.search,
            method: error.config.method,
            headers: {
              'Authorization': "Bearer " + (alternativeUrl.searchParams.get('jwt') || '')
            }
          };

          if (error.config.data) {
            try {
              requestOptions.data = JSON.parse(error.config.data);
            } catch (_) {}
          }

          console.log("[rum sdk axios interception]:", {
            errorRequestUrl: errorRequestUrl.href,
            alternativeRequestOptions: requestOptions
          });
          return axios.request(requestOptions);
        } else {
          delete apiLoopIndexMap[group.groupId];
        }
      }
    }

    return Promise.reject(error);
  });
};

var arrayMove = function arrayMove(arr, from, to) {
  var element = arr[from];
  arr.splice(from, 1);
  arr.splice(to, 0, element);
};

interceptAxios();
var index = {
  cache: cache,
  chain: chain,
  utils: utils,
  ethers: ethers
};

if (typeof window !== 'undefined') {
  window.QuorumLightNodeSDK = {
    cache: cache,
    chain: chain,
    utils: utils,
    ethers: ethers
  };
}

export default index;
export { ActionType, AnnounceType, ApproveType, cache, chain, utils };
//# sourceMappingURL=rum-sdk-nodejs.esm.js.map
